diff --git a/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java b/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java
index 0ccd839a6..835fe200c 100644
--- a/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java
+++ b/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java
@@ -3,9 +3,8 @@ package net.minecraft.core.world;
 import com.mojang.logging.LogUtils;
 import it.unimi.dsi.fastutil.objects.ObjectOpenHashSet;
 import net.minecraft.core.block.BlockLogicBed;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.data.gamerule.GameRules;
-import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.SpawnListEntry;
@@ -16,116 +15,108 @@ import net.minecraft.core.entity.monster.MobZombie;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.MobCategory;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.chunk.Chunk;
-import net.minecraft.core.world.chunk.ChunkCoordinate;
-import net.minecraft.core.world.chunk.ChunkCoordinates;
-import net.minecraft.core.world.chunk.ChunkPosition;
 import net.minecraft.core.world.config.spawning.SpawnerConfig;
 import net.minecraft.core.world.pathfinder.Node;
 import net.minecraft.core.world.pathfinder.Path;
 import net.minecraft.core.world.pathfinder.PathFinder;
-import net.minecraft.core.world.pos.ChunkPos;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.*;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3d;
 import org.slf4j.Logger;
 
-import java.util.HashSet;
 import java.util.List;
 import java.util.Set;
-public final class SpawnerMobs
-{
-    private static final Logger LOGGER = LogUtils.getLogger();
-    private static final Set<ChunkPos> ELIGIBLE_CHUNKS_FOR_SPAWNING = new ObjectOpenHashSet<>();
-    private static final Class<? extends Mob>[] NIGHT_SPAWN_ENTITIES;
-
-    static
-    {
+
+public final class SpawnerMobs {
+    private static final @NotNull Logger LOGGER = LogUtils.getLogger();
+    private static final @NotNull Set<@NotNull ChunkPos> ELIGIBLE_CHUNKS_FOR_SPAWNING = new ObjectOpenHashSet<>();
+    private static final @NotNull Class<? extends Mob>[] NIGHT_SPAWN_ENTITIES;
+
+    static {
         NIGHT_SPAWN_ENTITIES = new Class[] {
             MobSpider.class, MobZombie.class, MobSkeleton.class, MobZombieArmored.class
         };
     }
 
-    public SpawnerMobs()
-    {
-    }
-
-    private static ChunkPosition getRandomSpawningPointInChunk(World world, int chunkX, int chunkZ)
-    {
-        int newX = (chunkX * 16) + world.rand.nextInt(16);
-        int newY = world.rand.nextInt(world.getHeightBlocks());
-        int newZ = (chunkZ * 16) + world.rand.nextInt(16);
-        return new ChunkPosition(newX, newY, newZ);
+    private static @NotNull TilePosc getRandomSpawningPointInChunk(final @NotNull World world, final @NotNull ChunkPosc chunkPos) {
+        return new TilePos(
+            chunkPos,
+            new ChunkTilePos(
+                world.rand.nextInt(Chunk.CHUNK_SIZE_X),
+                world.rand.nextInt(world.getHeightBlocks()),
+                world.rand.nextInt(Chunk.CHUNK_SIZE_Z)
+            )
+        );
     }
 
-    public static int performSpawning(World world, SpawnerConfig spawnerConfig)
-    {
-        if(!spawnerConfig.canHostileSpawn(world) && !spawnerConfig.canPassiveSpawn(world)) { return 0; }
+    public static int performSpawning(final @NotNull World world, final @NotNull SpawnerConfig spawnerConfig) {
+        if (!spawnerConfig.canHostileSpawn(world) && !spawnerConfig.canPassiveSpawn(world)) {
+            return 0;
+        }
         ELIGIBLE_CHUNKS_FOR_SPAWNING.clear();
 
         for (int i = 0, playersSize = world.players.size(); i < playersSize; i++) {
-            Player player = world.players.get(i);
-            final int playerChunkX = MathHelper.floor(player.x / (double) Chunk.CHUNK_SIZE_X);
-            final int playerChunkZ = MathHelper.floor(player.z / (double) Chunk.CHUNK_SIZE_Z);
+            final @NotNull Player player = world.players.get(i);
+            final @NotNull ChunkPosc playerChunk = new ChunkPos(player);
             final byte spawnRadius = 8;
 
-            for (int dx = -spawnRadius; dx <= spawnRadius; ++dx) {
-                for (int dz = -spawnRadius; dz <= spawnRadius; ++dz) {
-                    if (world.isChunkLoaded(dx + playerChunkX, dz + playerChunkZ)) {
-                        ELIGIBLE_CHUNKS_FOR_SPAWNING.add(new ChunkPos(dx + playerChunkX, dz + playerChunkZ));
+            final @NotNull ChunkPos d = new ChunkPos();
+            for (d.x = -spawnRadius; d.x <= spawnRadius; d.x++) {
+                for (d.z = -spawnRadius; d.z <= spawnRadius; d.z++) {
+                    final @NotNull ChunkPos pos = new ChunkPos();
+                    if (world.isChunkLoaded(playerChunk.add(d.x, d.z, pos))) {
+                        ELIGIBLE_CHUNKS_FOR_SPAWNING.add(pos);
                     }
                 }
             }
         }
 
         int totalSpawned = 0;
-        final TilePos spawnPoint = world.getSpawnPoint();
-        final ChunkPos[] spawnChunks = new ChunkPos[3 * 3];
+        final @NotNull TilePos spawnPoint = world.getSpawnPoint();
+        final @NotNull ChunkPos @NotNull [] spawnChunks = new ChunkPos[3 * 3];
         for (int x = 0; x < 3; x++) {
             for (int z = 0; z < 3; z++) {
-                spawnChunks[x * 3 + z] = new ChunkPos((spawnPoint.x & 0xF) + (x - 1), (spawnPoint.z & 0xF) + (z - 1));
+                spawnChunks[x * 3 + z] = new ChunkPos(spawnPoint).add(x - 1, z - 1);
             }
         }
 
-
-        for (MobCategory creatureType : MobCategory.values()) {
-
+        for (final @NotNull MobCategory creatureType : MobCategory.values()) {
             if (creatureType.isPeaceful() && !spawnerConfig.canPassiveSpawn(world)) continue;
             if (!creatureType.isPeaceful() && !spawnerConfig.canHostileSpawn(world)) continue;
             if (world.countEntities(creatureType.getBaseClass()) > ((creatureType.getMaxCreaturesPerChunk() * ELIGIBLE_CHUNKS_FOR_SPAWNING.size()) / 256))
                 continue;
 
-            chunkLoop: for (ChunkPos chunk : ELIGIBLE_CHUNKS_FOR_SPAWNING) {
+            chunkLoop:
+            for (final @NotNull ChunkPos chunk : ELIGIBLE_CHUNKS_FOR_SPAWNING) {
                 boolean checkSpawnDist = false;
-                for (ChunkPos c : spawnChunks){
-                    if (c.equals(chunk)){
+                for (final @NotNull ChunkPos c : spawnChunks) {
+                    if (c.equals(chunk)) {
                         checkSpawnDist = true;
                         break;
                     }
                 }
 
-                if (!world.isChunkLoaded(chunk.x, chunk.z)) continue;
+                if (!world.isChunkLoaded(chunk)) continue;
 
-                final int blockX = chunk.x * Chunk.CHUNK_SIZE_X;
-                final int blockZ = chunk.z * Chunk.CHUNK_SIZE_Z;
-                final Biome biome = world.getBlockBiome(blockX, world.getHeightBlocks() - 1, blockZ);
-                final List<SpawnListEntry> spawnableList = biome.getSpawnableList(creatureType);
+                final @NotNull TilePos blockPos = new TilePos(chunk).add(0, world.getHeightBlocks() - 1, 0);
+                final @NotNull Biome biome = world.getBlockBiome(blockPos);
+                final @NotNull List<@NotNull SpawnListEntry> spawnableList = biome.getSpawnableList(creatureType);
 
-                if (spawnableList == null) continue;
                 if (spawnableList.isEmpty()) continue;
 
                 int totalSpawnRarity = 0;
 
-                SpawnListEntry spawnListEntry;
-                for (SpawnListEntry listEntry : spawnableList) {
+                for (final @NotNull SpawnListEntry listEntry : spawnableList) {
                     totalSpawnRarity += listEntry.spawnFrequency;
                 }
 
                 int calculatedSpawnChance = world.rand.nextInt(totalSpawnRarity);
-                spawnListEntry = spawnableList.get(0);
+                @NotNull SpawnListEntry spawnListEntry = spawnableList.get(0);
 
-                for (SpawnListEntry listEntry : spawnableList) {
+                for (final SpawnListEntry listEntry : spawnableList) {
                     calculatedSpawnChance -= listEntry.spawnFrequency;
                     if (calculatedSpawnChance < 0) {
                         spawnListEntry = listEntry;
@@ -133,33 +124,30 @@ public final class SpawnerMobs
                     }
                 }
 
-                EntityDispatcher.EntityDispatcherEntry<?> entry = EntityDispatcher.getInstance().entryForClass(spawnListEntry.entityClass);
+                final @Nullable EntityDispatcher.EntityDispatcherEntry<?> entry = EntityDispatcher.getInstance().entryForClass(spawnListEntry.entityClass);
                 if (entry == null || !spawnerConfig.canMobSpawn(entry.namespaceID)) continue;
 
-                final ChunkPosition pos = getRandomSpawningPointInChunk(world, chunk.x, chunk.z);
-                final int x = pos.x;
-                final int y = pos.y;
-                final int z = pos.z;
-                if (world.isBlockNormalCube(x, y, z) || world.getBlockMaterial(x, y, z) != creatureType.getSpawnMaterial())
+                final @NotNull TilePosc mobSpawnPos = getRandomSpawningPointInChunk(world, chunk);
+                if (world.isBlockNormalCube(mobSpawnPos) || world.getBlockMaterial(mobSpawnPos) != creatureType.getSpawnMaterial())
                     continue;
 
                 int countSpawned = 0;
 
                 final byte range = 6;
 
+                final @NotNull TilePos iPos = new TilePos();
                 for (int i = 0; i < 3; i++) {
-                    int ix = x;
-                    int iy = y;
-                    int iz = z;
+                    iPos.set(mobSpawnPos);
                     for (int spawnAttempt = 0; spawnAttempt < 4; ++spawnAttempt) {
-                        ix += world.rand.nextInt(range) - world.rand.nextInt(range);
-                        iy += world.rand.nextInt(2) - world.rand.nextInt(2);
-                        iz += world.rand.nextInt(range) - world.rand.nextInt(range);
-                        if (!world.isBlockLoaded(ix, iy, iz) || !canCreatureTypeSpawnAtLocation(creatureType, world, ix, iy, iz)) continue;
-
-                        final double dx = ix + 0.5D;
-                        final double dy = iy;
-                        final double dz = iz + 0.5D;
+                        iPos.x += world.rand.nextInt(range) - world.rand.nextInt(range);
+                        iPos.y += world.rand.nextInt(2) - world.rand.nextInt(2);
+                        iPos.z += world.rand.nextInt(range) - world.rand.nextInt(range);
+                        if (!world.isBlockLoaded(iPos) || !canCreatureTypeSpawnAtLocation(creatureType, world, iPos))
+                            continue;
+
+                        final double dx = iPos.x + 0.5D;
+                        final double dy = iPos.y;
+                        final double dz = iPos.z + 0.5D;
                         if (world.getClosestPlayer(dx, dy, dz, 24.0D) != null) continue;
 
                         // Forbid mob spawning in a 24 block radius around spawn
@@ -171,11 +159,14 @@ public final class SpawnerMobs
                             if (spawnDistanceSquared < 576.0F) continue;
                         }
 
-                        Mob mobToSpawn;
+                        final @Nullable Mob mobToSpawn;
                         try {
                             mobToSpawn = (Mob) EntityDispatcher.getInstance().createEntityInWorld(spawnListEntry.entityClass, world);
-                        } catch (Exception e) {
-                            LOGGER.error("Error spawning entity class '{}' class missing default constructor for World! Skipping spawn attempt!", spawnListEntry.entityClass.getSimpleName(), e);
+                        } catch (final Exception e) {
+                            LOGGER.error("Error spawning entity class '{}'! Skipping spawn attempt!", spawnListEntry.entityClass.getSimpleName(), e);
+                            return totalSpawned;
+                        }
+                        if (mobToSpawn == null) {
                             return totalSpawned;
                         }
 
@@ -197,18 +188,15 @@ public final class SpawnerMobs
         return totalSpawned;
     }
 
-    private static boolean canCreatureTypeSpawnAtLocation(MobCategory mobCategory, World world, int x, int y, int z)
-    {
-        if(mobCategory.getSpawnMaterial() == Material.water)
-        {
-            return world.getBlockMaterial(x, y, z).isLiquid() && !world.isBlockNormalCube(x, y + 1, z);
-        } else
-        {
-            return world.isBlockNormalCube(x, y - 1, z) && !world.isBlockNormalCube(x, y, z) && !world.getBlockMaterial(x, y, z).isLiquid();
+    private static boolean canCreatureTypeSpawnAtLocation(final @NotNull MobCategory mobCategory, final @NotNull World world, final @NotNull TilePosc tilePos) {
+        if (mobCategory.getSpawnMaterial() == Materials.WATER) {
+            return world.getBlockMaterial(tilePos).isLiquid() && !world.isBlockNormalCube(tilePos.up(new TilePos())) && world.getBlockData(tilePos) == 0;
+        } else {
+            return world.isBlockNormalCube(tilePos.down(new TilePos())) && !world.isBlockNormalCube(tilePos) && !world.getBlockMaterial(tilePos).isLiquid();
         }
     }
 
-    public static boolean isUnsafeToSleep(World world, Player player) {
+    public static boolean isUnsafeToSleep(final @NotNull World world, final @NotNull Player player) {
         if (!world.getGameRuleValue(GameRules.DO_NIGHTMARES)) {
             return false;
         }
@@ -220,59 +208,63 @@ public final class SpawnerMobs
             return false;
         }
 
-        Class<? extends Mob>[] entityClasses = NIGHT_SPAWN_ENTITIES;
+        final @NotNull Class<? extends Mob>[] entityClasses = NIGHT_SPAWN_ENTITIES;
         if (entityClasses != null && entityClasses.length != 0) {
-            boolean willSpawnEntity = false;
-            PathFinder pathFinder = new PathFinder(world);
+            final boolean willSpawnEntity = false;
+            final @NotNull PathFinder pathFinder = new PathFinder(world);
 
             // Make 20 attempts to find a path
             int i = 0;
             while (i < 20 && !willSpawnEntity) {
                 // Get a random location for the path start
-                int x = MathHelper.floor(player.x) + world.rand.nextInt(32) - world.rand.nextInt(32);
-                int z = MathHelper.floor(player.z) + world.rand.nextInt(32) - world.rand.nextInt(32);
-                int y = MathHelper.floor(player.y) + world.rand.nextInt(16) - world.rand.nextInt(16);
-                y = MathHelper.clamp(y, 1, world.getHeightBlocks());
-
-                int spawnY = y;
+                final @NotNull TilePosc initSpawnPos = new TilePos(
+                    MathHelper.floor(player.x) + world.rand.nextInt(32) - world.rand.nextInt(32),
+                    MathHelper.clamp(MathHelper.floor(player.y) + world.rand.nextInt(16) - world.rand.nextInt(16), 1, world.getHeightBlocks()),
+                    MathHelper.floor(player.z) + world.rand.nextInt(32) - world.rand.nextInt(32)
+                );
 
                 // Ensure we have enough space
-                while (spawnY > 2 && !world.isBlockNormalCube(x, spawnY - 1, z)) {
-                    spawnY--;
+                final @NotNull TilePos spawnPos = new TilePos(initSpawnPos.x(), initSpawnPos.y() - 1, initSpawnPos.z());
+                while (spawnPos.y > 2 && !world.isBlockNormalCube(spawnPos)) {
+                    spawnPos.y--;
                 }
 
                 // Make sure we're allowed to spawn in this Y coordinate
                 while (
-                        !canCreatureTypeSpawnAtLocation(MobCategory.monster, world, x, spawnY, z) &&
-                        spawnY < y + 16 &&
-                        spawnY < world.getHeightBlocks()
+                    !canCreatureTypeSpawnAtLocation(MobCategory.MONSTER, world, spawnPos) &&
+                        spawnPos.y < initSpawnPos.y() + 16 &&
+                        spawnPos.y < world.getHeightBlocks()
                 ) {
-                    spawnY++;
+                    spawnPos.y++;
                 }
 
-                if (spawnY < y + 16) {
-                    float entityX = x + 0.5f;
-                    float entityY = spawnY;
-                    float entityZ = z + 0.5f;
+                if (spawnPos.y < initSpawnPos.y() + 16) {
+                    final float entityX = spawnPos.x + 0.5f;
+                    final float entityY = spawnPos.y;
+                    final float entityZ = spawnPos.z + 0.5f;
 
-                    Mob entity;
-                    Class<? extends Mob> eClass = entityClasses[world.rand.nextInt(entityClasses.length)];
+                    final @Nullable Mob entity;
+                    final @NotNull Class<? extends Mob> eClass = entityClasses[world.rand.nextInt(entityClasses.length)];
                     try {
                         entity = EntityDispatcher.getInstance().createEntityInWorld(eClass, world);
-                    } catch (Exception e) {
+                    } catch (final Exception e) {
                         LOGGER.error("Exception instancing class '{}'!", eClass.getSimpleName(), e);
-                        return false;
+                        continue;
+                    }
+                    if (entity == null) {
+                        continue;
                     }
 
                     entity.moveTo(entityX, entityY, entityZ, world.rand.nextFloat() * 360.0f, 0.0f);
-                    if(entity.canSpawnHere())
-                    {
-                        Path pathEntity = pathFinder.findPath(entity, player, 32.0f);
-                        if(pathEntity != null && pathEntity.length > 1)
-                        {
-                            Node pathPoint = pathEntity.last();
-                            boolean isCollisionFree = world.checkBlockCollisionBetweenPoints(Vec3.fromPool(player.x, player.y + 1.5f, player.z), Vec3.fromPool(pathPoint.x, pathPoint.y + 1.5f, pathPoint.z)) == null;
-                            if(Math.abs(pathPoint.x + 0.5f - player.x) < 1.5 && Math.abs(pathPoint.z + 0.5f - player.z) < 1.5 && Math.abs(pathPoint.y + 0.5f - player.y) < 1.5 && isCollisionFree) {
+                    if (entity.canSpawnHere()) {
+                        final @Nullable Path entityPath = pathFinder.findPath(entity, player, 32.0f);
+                        if (entityPath != null && entityPath.length > 1) {
+                            final @Nullable Node pathPoint = entityPath.last();
+                            if (pathPoint == null) {
+                                continue;
+                            }
+                            final boolean isCollisionFree = world.checkBlockCollisionBetweenPoints(new Vector3d(player.x, player.y + 1.5f, player.z), new Vector3d(pathPoint.x, pathPoint.y + 1.5f, pathPoint.z)) == null;
+                            if (Math.abs(pathPoint.x + 0.5f - player.x) < 1.5 && Math.abs(pathPoint.z + 0.5f - player.z) < 1.5 && Math.abs(pathPoint.y + 0.5f - player.y) < 1.5 && isCollisionFree) {
                                 return true;
                             }
                         }
@@ -286,107 +278,101 @@ public final class SpawnerMobs
         return false;
     }
 
-	public static boolean performSleepSpawning(World world, List<Player> list)
-    {
-        if (!world.getGameRuleValue(GameRules.DO_NIGHTMARES))
-        {
+    public static boolean performSleepSpawning(final @NotNull World world, final @NotNull List<@NotNull Player> list) {
+        if (!world.getGameRuleValue(GameRules.DO_NIGHTMARES)) {
             return false;
         }
-		boolean spawnedEntity = false;
-		PathFinder pathFinder = new PathFinder(world);
+        boolean spawnedEntity = false;
+        final @NotNull PathFinder pathFinder = new PathFinder(world);
 
         // For each player in the player list
-		for (Player player : list)
-        {
+        for (final @NotNull Player player : list) {
             // Ignore conditions where monsters shouldn't spawn
-			if (!player.isPlayerSleeping())
-            {
+            if (!player.isPlayerSleeping()) {
                 continue;
             }
-            if (player.getGamemode().isPlayerInvulnerable())
-            {
+            if (player.getGamemode().isPlayerInvulnerable()) {
                 continue;
             }
 
-			Class<? extends Mob>[] entityClasses = NIGHT_SPAWN_ENTITIES;
-			if (entityClasses != null && entityClasses.length != 0)
-            {
-				boolean spawnedEntityForPlayer = false;
+            final @NotNull Class<? extends Mob>[] entityClasses = NIGHT_SPAWN_ENTITIES;
+            if (entityClasses != null && entityClasses.length != 0) {
+                boolean spawnedEntityForPlayer = false;
 
                 // Make 20 attempts to spawn a monster that can path
-				int i = 0;
-				while (i < 20 && !spawnedEntityForPlayer)
-                {
-                    // Get a random location for the monster to spawn
-					int x = MathHelper.floor(player.x) + world.rand.nextInt(32) - world.rand.nextInt(32);
-					int z = MathHelper.floor(player.z) + world.rand.nextInt(32) - world.rand.nextInt(32);
-					int y = MathHelper.floor(player.y) + world.rand.nextInt(16) - world.rand.nextInt(16);
-					y = MathHelper.clamp(y, 1, world.getHeightBlocks());
-					
-					int spawnY = y;
-
-                    // Ensure we spawn in an acceptable space
-					while(spawnY > 2 && !world.isBlockNormalCube(x, spawnY - 1, z))
-                    {
-                        spawnY--;
+                int i = 0;
+                while (i < 20 && !spawnedEntityForPlayer) {
+                    // Get a random location for the path start
+                    final @NotNull TilePosc initSpawnPos = new TilePos(
+                        MathHelper.floor(player.x) + world.rand.nextInt(32) - world.rand.nextInt(32),
+                        MathHelper.clamp(MathHelper.floor(player.y) + world.rand.nextInt(16) - world.rand.nextInt(16), 1, world.getHeightBlocks()),
+                        MathHelper.floor(player.z) + world.rand.nextInt(32) - world.rand.nextInt(32)
+                    );
+
+                    // Ensure we have enough space
+                    final @NotNull TilePos spawnPos = new TilePos(initSpawnPos.x(), initSpawnPos.y() - 1, initSpawnPos.z());
+                    while (spawnPos.y > 2 && !world.isBlockNormalCube(spawnPos)) {
+                        spawnPos.y--;
                     }
 
                     // Make sure we're allowed to spawn in this Y coordinate
-					while(
-                            !canCreatureTypeSpawnAtLocation(MobCategory.monster, world, x, spawnY, z) &&
-                            spawnY < y + 16 &&
-                            spawnY < world.getHeightBlocks()
-                    )
-                    {
-                        spawnY++;
+                    while (
+                        !canCreatureTypeSpawnAtLocation(MobCategory.MONSTER, world, spawnPos) &&
+                            spawnPos.y < initSpawnPos.y() + 16 &&
+                            spawnPos.y < world.getHeightBlocks()
+                    ) {
+                        spawnPos.y++;
                     }
 
-                    if (spawnY < y + 16) {
-						float entityX = x + 0.5f;
-						float entityY = spawnY;
-						float entityZ = z + 0.5f;
-
-						Mob entity;
-                        Class<? extends Mob> eClass= entityClasses[world.rand.nextInt(entityClasses.length)];
-						try
-                        {
-							entity = EntityDispatcher.getInstance().createEntityInWorld(eClass, world);
-						}
-                        catch (Exception e)
-                        {
+                    if (spawnPos.y < initSpawnPos.y() + 16) {
+                        final float entityX = spawnPos.x + 0.5f;
+                        final float entityY = spawnPos.y;
+                        final float entityZ = spawnPos.z + 0.5f;
+
+                        final @Nullable Mob entity;
+                        final @NotNull Class<? extends Mob> eClass = entityClasses[world.rand.nextInt(entityClasses.length)];
+                        try {
+                            entity = EntityDispatcher.getInstance().createEntityInWorld(eClass, world);
+                        } catch (final Exception e) {
                             LOGGER.error("Exception instancing class '{}'!", eClass.getSimpleName(), e);
-							return spawnedEntity;
-						}
-
-						entity.moveTo(entityX, entityY, entityZ, world.rand.nextFloat() * 360.0f, 0.0f);
-						if(entity.canSpawnHere())
-                        {
-							Path pathEntity = pathFinder.findPath(entity, player, 32.0f);
-							if(pathEntity != null && pathEntity.length > 1)
-                            {
-								Node pathPoint = pathEntity.last();
-                                boolean isCollisionFree = world.checkBlockCollisionBetweenPoints(Vec3.fromPool(player.x, player.y + 1.5f, player.z), Vec3.fromPool(pathPoint.x, pathPoint.y + 1.5f, pathPoint.z)) == null;
-								if(Math.abs(pathPoint.x + 0.5f - player.x) < 1.5 && Math.abs(pathPoint.z + 0.5f - player.z) < 1.5 && Math.abs(pathPoint.y + 0.5f - player.y) < 1.5 && isCollisionFree) {
-									TilePos emptyPos = BlockLogicBed.getNearestEmptyTilePos(world, new TilePos(player), 1);
-									if(emptyPos == null) {
-										emptyPos = new TilePos(x, spawnY + 1, z);
-									}
-									entity.moveTo(emptyPos.x + 0.5f, emptyPos.y, emptyPos.z + 0.5f, 0.0f, 0.0f);
-									entity.spawnInit();
-									world.entityJoinedWorld(entity);
-									player.wakeUpPlayer(true, false);
-									world.playBlockEvent(null, LevelListener.EVENT_BLOCK_BREAK, (int) player.x, (int) player.y - 1, (int) player.z, world.getBlockId((int) player.x, (int) player.y - 1, (int) player.z));
-									entity.playLivingSound();
-									spawnedEntity = true;
-									spawnedEntityForPlayer = true;
-								}
-							}
-						}
-					}
+                            continue;
+                        }
+                        if (entity == null) {
+                            continue;
+                        }
+
+                        entity.moveTo(entityX, entityY, entityZ, world.rand.nextFloat() * 360.0f, 0.0f);
+                        if (entity.canSpawnHere()) {
+                            final @Nullable Path pathEntity = pathFinder.findPath(entity, player, 32.0f);
+                            if (pathEntity != null && pathEntity.length > 1) {
+                                final @Nullable Node pathPoint = pathEntity.last();
+                                if (pathPoint == null) {
+                                    continue;
+                                }
+
+                                final boolean isCollisionFree = world.checkBlockCollisionBetweenPoints(new Vector3d(player.x, player.y + 1.5f, player.z), new Vector3d(pathPoint.x, pathPoint.y + 1.5f, pathPoint.z)) == null;
+                                if (Math.abs(pathPoint.x + 0.5f - player.x) < 1.5 && Math.abs(pathPoint.z + 0.5f - player.z) < 1.5 && Math.abs(pathPoint.y + 0.5f - player.y) < 1.5 && isCollisionFree) {
+                                    TilePos emptyPos = BlockLogicBed.getNearestEmptyTilePos(world, new TilePos(player), 1);
+                                    if (emptyPos == null) {
+                                        emptyPos = spawnPos.up(new TilePos());
+                                    }
+                                    entity.moveTo(emptyPos.x + 0.5f, emptyPos.y, emptyPos.z + 0.5f, 0.0f, 0.0f);
+                                    entity.spawnInit();
+                                    world.entityJoinedWorld(entity);
+                                    player.wakeUpPlayer(true, false);
+                                    final @NotNull TilePos playerDown = new TilePos(player).down();
+                                    world.playBlockEvent(null, playerDown, LevelListener.EVENT_BLOCK_BREAK, world.getBlockId(playerDown));
+                                    entity.playLivingSound();
+                                    spawnedEntity = true;
+                                    spawnedEntityForPlayer = true;
+                                }
+                            }
+                        }
+                    }
                     i++;
-				}
-			}
-		}
-		return spawnedEntity;
-	}
+                }
+            }
+        }
+        return spawnedEntity;
+    }
 }
